<?php
// for new registerations and reset-password (from the user dashboard)
function prepare_new_member($post){
	$post->password = password_hash($post->password, PASSWORD_DEFAULT);
	if(!isset($post->token)){
		$post->username = $post->first_name.$post->last_name;
		$post->username = substr(str_replace(" ", "_", cleanUp(strtolower($post->username))), 0, 25);
	}
	return($post);
}

function welcome_to_apex($member_id){
	$response = apex_login($member_id, "registration");
	return $response;
}

function apex_login($user, $registration = false){
	global $controller;
	$response = new stdClass;
	$messenger = new Messenger($controller);
	$company = $controller->company();
	$messenger->pinAction = "login";
	if(gettype($user) !== "object"){
		$user = $controller->getFromTable("users", "id=$user", 1, 0)[0];
	}

	if($registration){
		$welcome_mail = (object)[
			"subject" => "Welcome to {$company->name}",
			"body" => "Dear {$user->first_name}, We are more than happy to recieve you in our team. You have one more step to complete, once you have successfully logged in, choose a package and start earning from your investments.",
			"to" => $user->email,
			"from" => $company->email,
			"from_name" => ucwords($company->name),
			"to_name" => "{$user->first_name}",
			"address" => $company->address,
			"user_id" => $user->id
		];

		$messenger->sendMail($welcome_mail);

	}
	$_SESSION["member_id"] = $user->id;
	$_SESSION["email"] = $user->email;
	$_SESSION["pic"] = $user->picture_ref;
	$_SESSION["member_name"] = "{$user->first_name}";
	$_SESSION['mloggedin'] = true;
	// $loginCode = sendCode($messenger, $user);
	$response->status = 1;
	$response->message = "Welcome, {$user->first_name}";
	return $response;
}

function sendCode($messenger, $user) {
	global $controller;
	$loginCode 	= rand(100000,999999);
	$actions 		= [
		"login"=>"login",
		"resetPassword"=>"reset password",
		"wallet"=>"modify your wallet",
		"update-email"=>"update your email",
		"changeWallet"=>"change wallet address",
		"withdrawal"=>"authenticate your withdrawal",
	];
	$action 		= $messenger->pinAction;
	$title  		= $actions[$action];
	$company 		= $controller->company();
	$mail 			= (object)[
		'subject'		=>	"Token",
		'body'			=>	"Use this token to {$title}. \n $loginCode",
		'from'			=>	$company->email,
		'to'				=>	$user->email,
		'from_name'	=>	$company->name,
		'to_name'		=>	"{$user->first_name}",
		'address'		=>	$company->address,
		'user_id'		=>	$user->id
	];
	$response 	= $messenger->sendMail($mail);
	$response->k=$user->id;
	if(!in_array($controller->getServer(), $controller->getLocalServers())){
		$text_response = $messenger->loftSMS([
		  'phone'		=>	$user->phone,
		  'message'	=>	$loginCode,
		  'from_name'	=>	$company->name,
		]);
	}
	$_SESSION[$action] = $loginCode;
	if(in_array($controller->getServer(), $controller->getLocalServers())){
		$response->{$action} = $loginCode;
	}
	return $response;
}

//Inserts an activity log into the database
function activity($post){
	$site 	 = new Generic;
	$db = $site->connect();
	$uri = $site->getURIdata();
	$response = $site->insert($post, "log");
	// $db->close();
	unset($db);
	return $response;
}

//Function that runs when an admin confirms a payments
//This sets the account status to either active or inactive
function manageAccount($trans_id){
	global $generic;
	$response=new stdClass;
	$session=(object)$_SESSION;
  $trns 	= $generic->getFromTable("tbl_transaction", "id={$trans_id}")[0];
	$acc_id = $trns->account_id;
	$account= $generic->getFromTable("tbl_accounts", "id={$acc_id}")[0];
	$db 		= $generic->connect();
	if(!empty($trns->status)){
		$sel = $db->query("UPDATE tbl_accounts SET paid='1', status='1' WHERE id='$acc_id'") or die($db->error);
	}else{
		$sel = $db->query("UPDATE tbl_accounts SET status='0' WHERE id='$acc_id'") or die($db->error);
	}
	if($trns->status == 1 && $account->status==0){
		$user = $generic->user();
		activity([
			"user_id" => $trns->user_id,
			"action" => "Update",
			"location" => "tbl_transaction",
			"location_id" => $acc_id,
			"submitType" => "insert",
			"type" => "other",
			"description" => "{$user->name_col} Confirmed your payment of $ {$trns->amount}"
		]);
	}
	$response->status = 1;
	return $response;
}

function confirm_token($post){
	if($_SESSION[$post->action] != $post->token){
		$post->error = "Token does not match";
	}
	return $post;
}
function changePassword($post){
	$post = confirm_token($post);
	if(empty($post->error)){
		$post = prepare_new_member($post);
		$post->id = $_SESSION["member_id"];
	}
	return $post;
}
function setActionForCode($post){
	global $cookie;
	global $controller;
	$session = (object)$_SESSION;
	$post = (object)$post;
	require_once($cookie[2].$cookie[1]."controllers/Messenger.php");
	$messenger= new Messenger($controller);
	$user = $controller->getFromTable("users", "id={$session->member_id}", 1, 0)[0];
	$messenger->pinAction = $post->action;
	$response = sendCode($messenger, $user);
	return $response;
}
?>
