<?php
$user_id = isset($_SESSION["user_id"]) ? $_SESSION["user_id"] : 0;
$user_al = isset($_SESSION["accesslevel"]) ? $_SESSION["accesslevel"] : 4;
$actLog = $user_al == 4 ? "" : ", user_id=$user_id";


$param = [
	"admin_signin"=> [ //Signin Parameters
		"table" 			=> "users",
		"primary_key"	=> "id",
		"username_col"=> "username",
		"password_col"=> "password",
		"name_col"  	=> "first_name",
		"email_col" 	=> "email",
		"image_col"		=> "picture_ref",
		"interface"		=> "signin1",
		"status_col"	=> "type",
		"status_val"	=> 1,
		"callback" 		=> "signin_log",
	],

	"organization" 	=> [//The current organization using the code
		"table"				=> "company_info",
		"primary_key"	=> "id",
		"page_title"	=> "Settings",
		"display_fields" 	=> [
			[
				"column" 		 	=> "name",
				"description"	=> "This Company",
				"component"		=> "span",
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"left",
					"section_title"=>"Basic Company Info",
					"section_elements"=>[
						[
							"column"=>"name",
							"description"=>"Business Name",
							"required"=>true,
							"type"=>"text",
							"class"=>"col s12 m12"
						],[
							"column"=>"email",
							"description"=>"Email Address",
							"required"=>true,
							"type"=>"text",
							"class"=>"col s12 m12"
						],[
							"column"=>"website",
							"description"=>"Website",
							"required"=>false,
							"type"=>"text",
							"class"=>"col s12 m12"
						],[
							"column"=>"address",
							"description"=>"Address",
							"required"=>false,
							"type"=>"text",
							"class"=>"col s12 m12"
						],[
							"column"=>"phone",
							"description"=>"Phone",
							"type"=>"text",
							"required"=>true,
							"class"=>"col s12 m12",

						]
					]
				],[
					"position"=>"right",
					"section_title"=>"Company Logo",
					"section_elements"=>[
						[
							"column"=>"logo_ref",
							"description"=>"Logo",
							"required"=>true,
							"type"=>"items",
							"value"=>2,
							"class"=>"col s12 m12"
						]
					]
				],[
					"position"=>"right",
					"section_title"=>"Company Branches",
					"section_elements"=>[
						[
							"column"=>"other",
							"description"=>"Details",
							"type"=>"description",
							"class"=>"col s12 m12 ",
							"required"=>false
						]
					]
				]
			]
		]
	],//new page

	"role"=>[
		"table"=>"roles",
		"primary_key"=>"roleid",
		"page_title"=>"Roles",
		"display_fields"=>[
			[
				"column"=>"rolename",
				"description"=>"Role Name",
				"component"=>"boldSpan"
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"Role Info",
					"section_elements"=>[
						[
							"column"=>"rolename",
							"description"=>"Role Name",
							"type"=>"text",
							"required"=>true,
							"class"=>"col s12 m12"
						],[
							"column"=>"roledesc",
							"description"=>"Role Name",
							"required"=>true,
							"type"=>"roles",
							"class"=>"col s12 m12"
						]
					]
				]
			]
		]
	],

	"log"=>[
		"table"=>"activitylog",
		"primary_key"=>"id",
		"page_title"=>"log",
		"ModalForm"=>true,
		"listFAB"=>false,
		"retrieve_filter"=>"type='admin' $actLog",
		"sort_col"=>"id DESC",
		"display_fields"=>[
			[
				"column"=>"action",
				"description"=>"Action",
				"component"=>"span"
			],[
				"column"=>"description",
				"description"=>"Description",
				"component"=>"span"
			],[
				"column"=>"date",
				"description"=>"Time",
				"component"=>"span",
				"action"=>"datetime"
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"Log Details",
					"section_elements"=>[
						[
							"column"=>"description",
							"description"=>"Description",
							"type"=>"textarea",
							"readonly"=>true,
							"class"=>"col s12"
						]
					]
				]
			]
		]
	],

	"subscribers"=>[
		"table"=>"subscribers",
		"primary_key"=>"id",
		"page_title"=>"Subscribers",
		"ModalForm"=>true,
		"listFAB"=>["delete"],
		"display_fields"=>[
			[
				"column"=>"email",
				"description"=>"Email",
				"component"=>"span"
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"Subscriber Info",
					"section_elements"=>[
						[
							"column"=>"name",
							"description"=>"Subscriber Name",
							"type"=>"text",
							"required"=>true,
							"class"=>"col s12 m12"
						],[
							"column"=>"email",
							"description"=>"Email",
							"type"=>"email",
							"required"=>true,
							"class"=>"col s12 m12"
						]
					]
				]
			]
		]
	],

	"users"=>[
		"table"=>"users",
		"primary_key"=>"id",
		"page_title"=>"Users",
		"fixed_values"=>"type=1, status=1",
		"retrieve_filter"=>"type=1",
		"display_fields"=>[
			[
				"column"=>"first_name",
				"description"=>"First Name",
				"component"=>"span"
			],[
				"column"=>"last_name",
				"description"=>"Last Name",
				"component"=>"span"
			]

		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"left",
					"section_title"=>"User Info",
					"section_elements"=>[
						[
								"column"=>"first_name",
								"description"=>"First Name",
								"required"=>true,
								"type"=>"text",
								"class"=>"col s12 m6"
						],[
								"column"=>"last_name",
								"description"=>"Last Name",
								"required"=>true,
								"type"=>"text",
								"class"=>"col s12 m6"
						],[
								"column"=>"gender",
								"description"=>"Gender",
								"required"=>true,
								"type"=>"select",
								"source"=>"gender",
								"class"=>"col s12 m6"
						],[
								"column"=>"dob",
								"description"=>"Date Of Birth",
								"required"=>true,
								"type"=>"date",
								"class"=>"col s12 m6"
							]
					]
				],[
					"position"=>"left",
					"section_title"=>"Contact Info",
					"section_elements"=>[
						[
							"column"=>"phone",
							"description"=>"Phone Number",
							"class"=>"col s12 m12",
							"type"=>"text"
						],[
							"column"=>"email",
							"description"=>"Email",
							"class"=>"col s12 m12",
							"type"=>"text"
						],[
							"column"=>"website",
							"description"=>"LinkedIN profile Address",
							"class"=>"col s12 m12",
							"type"=>"text"
						]
					]
				],[
					"position"=>"right",
					"section_title"=>"Profile Picture",
					"section_elements"=>[
						[
							"column"=>"picture_ref",
							"description"=>"Logo",
							"type"=>"picture",
							"class"=>"col s12 m12"
						]
					]
				],[
					"position"=>"right",
					"section_title"=>"Security Settings",
					"section_elements"=>[
						[
							"column"=>"username",
							"description"=>"Username",
							"class"=>"col s12 m12",
							"type"=>"text",
							"required"=>true
						],[
							"column"=>"password",
							"description"=>"Password",
							"type"=>"password",
							"required"=>true,
							"class"=>"col s12 m12"
						],[
							"column"=>"roleid",
							"description"=>"Role",
							"type"=>"select",
							"required"=>true,
							"class"=>"col s12 m12",
							"source"=>"role",
						],[
							"column"=>"accesslevel",
							"description"=>"Access Level",
							"type"=>"select",
							"required"=>true,
							"class"=>"col s12 m12",
							"source"=>"accessLevel",
						]
					]
				]
			]
		]
	],

	"products"=>[
		"table"=>"content",
		"primary_key"=>"id",
		"page_title"=>"product",
		"fixed_values"=>"type='product',date_uploaded=now(),no_of_views='0', user_id='$user_id'",
		"extra_values"=>"date_updated=now()",
		"retrieve_filter"=>"type='product'",
		"sort"=>"title DESC",
		// "listFAB"=>["add"],
		// "ModalForm"=>true,
		"display_fields"=>[
			[
				"column"=>"title",
				"description"=>"Products",
				"component"=>"span",
				"class" =>"col s12 l4"
			],
			[
				"column"=>"business",
				"description"=>"Amount (N)",
				"component"=>"span",
				"class" =>"col s6 l2"
			],
			[
				"column"=>"no_of_views",
				"description"=>"Views",
				"component"=>"span",
				"class" =>"col s12 l3"
			],
			[
				"column"=>"date_uploaded",
				"description"=>"Date",
				"action"=>"datetime",
				"component"=>"span",
				"class" =>"col s12 l3"
			]
		],

		"form"=>[
			"sections"=>[
				[
					"position"=>"left",
					"section_title"=>"Product Details",
					"section_elements"=>[
						[
							"column"=>"title",
							"description"=>"Product Name",
							"type"=>"text",
							"required"=>true,
							"class"=>"col s12 m12"
						],[
							"description"=>"Slogan",
							"column"=>"label",
							"type"=>"text",
							"class"=>"col s12 m12"
						],[
							"column"=>"business",
							"description"=>"Price (N)",
							"type"=>"number",
							"required"=>true,
							"class"=>"col s12 m6",
						],[
							"description"=>"Pubish Status",
							"column"=>"status",
							"source"=>"status",
							"type"=>"switch",
							"class"=>"col s12 m6"
						]

					]
				],[
						"position"=>"right",
						"section_title"=>"Product Images",
						"section_elements"=>[
						[
							// "description"=>"Add Features",
							"column"=>"image",
							"type"=>"items",
							"value"=>4,
							"class"=>"col s12 m12"
						]
					]
				],[
						"position"=>"left",
						"section_title"=>"Plan Instructions",
						"section_elements"=>[
						[
							// "description"=>"Add Features",
							"column"=>"body",
							"type"=>"richtext-body",
							"class"=>"col s12 m12"
						]
					]
				]
			]
		]
	],

	"slider"=>[
		"table"=>"company_info",
		"primary_key"=>"id",
		"fixed"=>"1",
		"page_title"=>"Home Page Slider",
		"form"=>[
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"Home Page Slider",
					"section_elements"=>[
						[
							"column"=>"slider",
							"description"=>"Home Page Slider",
							"required"=>true,
							"type"=>"generic-slider",
							"class"=>"col s12 m12"
						]
					]
				]
			]
		]
	],
];



?>
