<?php
require_once("Generic.php");
require_once("Messenger.php");
require_once("ParamControl.php");

class Auth extends Generic {
	public static $user = [];
	public static $column_maps;
	public static $identity_val;
	public static $identity_key;
	public static $identity_col;
	public static $ParamControl;

	public function __construct($get_user, $param_name = "admin_signin", $admin = ""){
		//$get_user can either user id, email, username or an array that has any of these user identifier keys as mapped in the formName.
		parent::__construct($admin);
		if($get_user !== null){
			$ParamControl 	= new ParamControl($this);
			$param					= $ParamControl->get_params($param_name);
			//Define an array of the column maps needed to authenticate a user.
			//Check if the required columns exist in the Param suplied
			$required_admin = ["image_col", "interface", "status_col", "status_val"];
			$required_cols  = ["table", "primary_key", "username_col", "password_col", "name_col", "email_col"];
			//This line exracts the values of the user identifier columns from the $param_name supplied as the actual columns in the database. Any of these columns is used to identify a user.
			$user_id_cols 	= array_extract($param, ["username_col", "primary_key", "email_col", "phone_col"]);
			if($param_name == "admin_signin"){$required_cols = array_merge($required_cols, $required_admin);}
			$not_exist 			= array_diff($required_cols, array_keys((array)$param));
			if(!empty($not_exist))die(implode(",", $not_exist)." were not found in the param you supplied");
			if(gettype($get_user) == "array"){
				//If an array is supplied, there is no way to know the key that would be used to identify the user as the $get_user, so there is a need to search the array to find the key in $user_id_cols, then extract the value as the $get_user;
				$user_array = $get_user;
				$get_user = array_extract($user_array, $user_id_cols);
				if(empty($get_user[0]))die("User identifier key not set");
				$get_user = $get_user[0];
				$identity_key = array_search($get_user, $user_array);
			}
			if(is_numeric($get_user) && strlen($get_user)==11)
			$identity_col = "phone_col";
			elseif(is_numeric($get_user))
			$identity_col = "primary_key";
			else if(stripos($get_user, "@") !== false)
			$identity_col = "email_col";
			else $identity_col 	= "username_col";
			if(empty($identity_key))$identity_key = $param->{$identity_col};
			self::$column_maps 				= $param;
			self::$identity_val	 			= $get_user;
			self::$identity_col				=	$identity_col;
			self::$identity_key				=	$identity_key;
			self::$ParamControl				=	$ParamControl;
			$this->user();
		}
	}

	public function user($get_user = null){
		//identify the $get_user parameter
		if($get_user !== null){
			self::__construct($get_user, $param_name = "admin_signin");
		}
		$column_maps 	= self::$column_maps;
		$identity_col = self::$identity_col;
		$identity_val	= self::$identity_val;
		if(empty(self::$user) && !empty($identity_val)){
			$this->getURIdata();
			$db 	= $this->connect();
			$ucol = $column_maps->{$identity_col};
			//see("$ucol=$identity_val");
			$user = $this->getFromTable($column_maps->table, "$ucol=$identity_val", 1, 1);
			if(count($user)){
				$user = $user[0];
				$user->roledesc = "";
				if(!empty($user->roleid))
				$user->roledesc = $this->getFromTable("roles","roleid={$user->roleid}", 1, 1, "", false, "roledesc")[0]->roledesc;
				foreach ($user as $key => $keyval) {
					$colkey = array_search($key, (array)$column_maps);
					if($colkey !== false){
						$user->{$colkey} = $keyval;
						if($key !== $colkey)unset($user->{$key});
					}
				}
				$user->image_col 	= file_path($user->image_col, $this->domain.$this->backend."images/default.png");
				self::$user = $user;
			}else{
				$user = null;
			}
		}
		return self::$user;
	}

	public function role(){
		$user = self::$user;
		$response = null;
		if(!empty($user->roledesc)){
			$return = [];
			$count  = 1;
			$role 	= explode(",", $user->roledesc);
			foreach($role as $key => $group){
				if(empty($group)) continue;
				$p		=	explode(':', $group);
				if(!empty($p[1]))$return[$p[0]][$p[1]]=1;
			}
			$response = $return;
		}
		return($response);
	}

	public function forgotPassword($post){
		//Change array type to object, instantiate the param class, extract the param data from formName supplied
		$response 		= new stdClass;
    $post         = gettype($post) == 'array' ? (object)$post : $post;
    $param        = self::$column_maps;
		$user 				= self::$user;
		$company			=	$this->company();
		$response->status  = 0;
		//Check if the selected param really exists and has paramters
    if(!empty($param)) {
			$code = mt_rand(100000, 999999);
			if(!empty($user)){
				if(!empty($user->email_col) && !empty($company->email)){
					$messenger= new Messenger($this);
					$message  = "Use this token code:'$code' to reset your password. This token expires in the next 10mins.";
					$data = [
						'subject'=>"Reset Password Token",
						'body'		=>	$message,
						'from'		=>	$company->email,
						'to'			=>	$user->email_col,
						'from_name'=>	$company->name,
						'to_name'	=>	$user->name_col,
						'address'	=>	$company->address,
						'user_id'	=>	$user->primary_key,
					];
					$response = $messenger->sendMail($data);
					if(isset($response->status)){
	          $_SESSION["code"]	= $code;
	          $response->email 	= $user->email_col;
	          $response->name 	= $user->name_col;
	          $response->id 		= $user->primary_key;
	          $response->j 		= $code;
	        }
				}else {$response->message = "Check if Company email and User's email exists";}
			}else{$response->message = "Not A registered User";}
		}else{$response->message = "The formName you supplied is invalid | does'nt have paramters";}
	    return($response);
  }

  public function resetPassword($post){
		$response 		= new stdClass;
    $post         = gettype($post) == 'array' ? (object)$post : $post;
    $param        = self::$column_maps;
		$user 				= self::$user;
		$identity_key = self::$identity_key;
		//Set default response to error , so it can only change when validated
		$response->status  = 0;
		if(!empty($param) && !empty($user)) {
			if(!empty($_SESSION["code"])){
				if(intval($post->token) === intval($_SESSION["code"])){
					if($post->password === $post->password2){
						if(isset($param->password_hash)){
							if($param->password_hash == "password_hash"){
								$post->password = password_hash($post->password, PASSWORD_DEFAULT);
							}else{
								$post->password = call_user_func_array($param->password_hash, [$post->password]);
							}
						}
						$post->submitType = "update";
						$post->{$param->password_col} = $post->password;
						$post->{$param->primary_key} = $post->{$identity_key};
						//Make sure you are sending only primary key
						if($identity_key !== $param->primary_key)unset($post->{$identity_key});
						$response = $this->insert($post, $param);
						if($response->status)$response->message = "Successfully Changed";
					}else{$response->message = "Passwords Do not Match !!!";}
				}else{$response->message = "Token is incorrect";}
			}else{$response->message = "Token has expired";}
		}
		return $response;
  }

  public function login($data) {
		//Change array type to object, instantiate the param class, extract the param data from formName supplied
		$response 		= new stdClass;
    $post         = gettype($data) == 'array' ? (object)$data : $data;
    $param        = self::$column_maps;
		$response->status = 0;
		//Check if the selected param really exists and has paramters
    if(!empty($param)) {
			//Make sure all keys are in lowercase
			$post 					= (object)array_change_key_case((array)$post);
			//Extract password from the post after using the formName suppied to match the mapped column names;
			$login_password = array_extract((array)$post, [$param->password_col])[0];
			$user 					= $this::user();
			//Start authentication
      if(!empty($user)) {
        $passwordVerified = false;
				if (isset($param->password_hash) ) {
          $param->password_hash = ($param->password_hash == "md5") ? "mymd5Verify" : $param->password_hash ;
          if($param->password_hash == "password_hash"){
						$passwordVerified = password_verify($login_password, $user->password_col);
					}else{
						$passwordVerified = call_user_func_array($param->password_hash, [$login_password, $user->password_col]);
					}
        }else{
          $passwordVerified = ($login_password === $user->password_col) ? true : false ;
        }
        if ($passwordVerified === true) {

					$required_admin = ["image_col", "interface", "status_col", "status_val"];
					$required_cols  = ["table","primary_key","image_col","username_col","password_col", "name_col", "email_col"];
					if($post->formname == "admin_signin"){
						$required_cols = array_merge($required_cols, $required_admin);
					}
					$response				= array_extract((array)$user, $required_cols, true);
					$response 			= (object)array_remap($response, $param);
					$_SESSION['loggedin'] = true;
					$response->status = 1;
					$response->message = "Login Successful";
					if(!empty($param->callback))$response = call_user_func_array($param->callback, [$response]);
        }else { $response->message = "Password does not match"; }
      } else { $response->message = "User not found, Try Creating an Account"; }
    }else{ $response->message = "The formName you supplied is invalid | does'nt have paramters"; }
    return $response;
  }
}


?>
