<?php
	class ParamControl{
		public static $front;
		public static $roles;
		public static $param;
		public static $link_biz;
		public static $actions;
		public static $sources;
		public static $generic;

		function __construct(Generic $generic){
			$uri = new stdClass;
			if(!empty($_COOKIE["siteData"])){
				list($uri->site, $uri->backend, $uri->root) = explode(",", $_COOKIE["siteData"]);
				$uri->root = $uri->root.$uri->backend;
			}else{
				$uri = $generic->getURIdata();
				$uri->root = absolute_filepath($uri->site.$uri->backend);
			}
			require_once($uri->root."backendProject/parameters/param_roles.php");
			require_once($uri->root."backendProject/parameters/param_sources.php");
			require_once($uri->root."backendProject/parameters/param_generic.php");
			require_once($uri->root."backendProject/parameters/param_actions.php");
			require_once($uri->root."backendProject/parameters/param_frontend.php");
			require_once($uri->root."backendProject/parameters/param_transactions.php");
			$loads 	= ["front", "param", "actions", "roles", "sources", "link_biz"];
			self::$generic = $generic;
			foreach ($loads as $key => $param_name) {
				if(isset(${$param_name})){
					$parameter = ${$param_name};
					$parameter = ${$param_name};
					self::${$param_name} = json_decode(json_encode($parameter));
				}
			}
		}

		//Get all params within a page
		public function get_page_param($param_page){
			$response 	= null;
			if(!empty(self::${$param_page})){
				$response = self::${$param_page};
			}
			return $response;
		}

		//Get all pages params merged together or one param from any param page within the array below
		public function get_params($pageType = ""){
			$loads 	= ["front", "param", "actions", "link_biz"];
			$merged	= [];
			foreach ($loads as $key => $array) {
				if(!empty(self::${$array})){
					$array_data = self::${$array};
					$array_data	= json_decode(json_encode($array_data), true);
					$merged			= array_merge($merged, $array_data);
				}
			}
			if(!empty($pageType)){
				if(isset($merged[$pageType])){
					$merged = $merged[$pageType];
				}else $merged = [];
			}
			return json_decode(json_encode($merged));
		}

		//Get all sources from the source param, or one from it
		public function load_sources($pageType = ""){
			$sources	 = self::$sources;
			if(!empty($pageType) && isset($sources->{$pageType})){
				$sources = $sources->{$pageType};
			}
			return $sources;
		}

		//The the default role from the role param and format it to string (like a user's roledesc)
		public function default_role(){
			$roles	 = self::$roles;
			$response = null;
			if(!empty($roles)){
				$return 	= [];
				$group_id	= 1;
				foreach($roles as $group_name => $group_data){
					$links_id	= 1;
					foreach ($group_data->links as $links_key => $links_data) {
						$return[]="$group_id:$links_id";
						$links_id++;
					}
					$group_id++;
				}
				$response = implode(",", $return);
			}
			return($response);
		}

		//Extracts and rebuilds form elements to be usable by FormController class
		public function extract_form($form){
			$form = json_decode(json_encode($form), true);
			$data=array();
			$vs=!empty($form['sections']) ? $form['sections'] : array();
			foreach($vs as $kt1 => $v1){
				if(empty($v1['position']))continue;
				$positions = explode(' ',trim($v1['position']));
				$k0 = isset($positions[1]) ? trim($positions[1]) : '0';
				$k = trim($positions[0]);
				$k1=!empty($v1['section_title']) ? $v1['section_title'] : '';
				$vf=!empty($v1['section_elements']) ? $v1['section_elements'] : array();
				$data['form_position'] = $k;
				foreach($vf as $k2 => $v2){
					if(!empty($v2['column'])){
						$data['columns'][$k0][$k][$k1][]=$v2['column'];
						$data['coldesc'][$k0][$k][$k1][]=!empty($v2['description']) ? $v2['description'] : '';
						$data['required'][$k0][$k][$k1][]=!empty($v2['required']) ? $v2['required'] : '';
						$data['disabled'][$k0][$k][$k1][]=!empty($v2['disabled']) ? $v2['disabled'] : false;
						$data['value'][$k0][$k][$k1][]=isset($v2['value']) ? $v2['value'] : '';
						$data['readonly'][$k0][$k][$k1][]=!empty($v2['readonly']) ? $v2['readonly'] : false;
						$data['order'][$k0][$k][$k1][]=!empty($v2['type']) ? $v2['type'] : '';
						$data['src'][$k0][$k][$k1][]=!empty($v2['source']) ? $this->source_encode($v2['source']): '';
						$data['cls'][$k0][$k][$k1][]=!empty($v2['class']) ? $v2['class'] : '';
						$data['empty'][$k0][$k][$k1][] = isset($v2['empty']) ? $v2['empty'] : true;
						$data['placeholder'][$k0][$k][$k1][] = !empty($v2['placeholder']) ? $v2['placeholder'] : '';
						$data['event'][$k0][$k][$k1][]=!empty($v2['event']) ? $v2['event'] : '';
						$data['target'][$k0][$k][$k1][]=!empty($v2['target']) ? $v2['target'] : '';
						$data['mult'][$k0][$k][$k1][]=isset($v2['multiple']) ? $v2['multiple'] : false;
						$data['col'][]=$v2['column'];
						$data['desc'][]=!empty($v2['description']) ? $v2['description'] : '';
					}
				}
			}
			return $data;
		}
		//Converts back and array to a linear string.
		//This is used by the filter control and transactions widget
		public function jsonRe_encode($arr){
			if(gettype($arr) =="array"){
				$jj = "";
				foreach($arr as $k => $v){
					$jn = "";
					$n = empty($v->name)? '':$v->name;
					$c = empty($v->column)? '':$v->column;
					$s = empty($v->source)? '':$v->source;
					$v = empty($v->value)? '':$v->value;
					$jn = $c.','.$n.','.$s.','.$v.'|';
					$jj .= $jn;
				}
				return(substr($jj,0,-1));
			}else return(0);
		}

		public function source_encode($source){
			if(gettype($source) =="array"){
				$source = json_decode(json_encode(array_change_key_case($source)));
				if(gettype($source->column) == "array")$source->column = implode("*", $source->column);
				$source = "{$source->pagetype}~{$source->column}";
			}
			return($source);
		}

		public function source_decode($source){
			$array_source = explode("~", $source);
			if(!empty($array_source[1])){
				$columns = array_unique(explode("*", $array_source[1]));
				$columns = implode(",", $columns);
				$source = array("pageType"=>$array_source[0], "column"=>$columns);
			}
			return($source);
		}

		//Extracts form for Transactions
		function extractFormSubset($form, $key){
			$dt=array();
			$form = json_decode(json_encode($form), true);
			$vs=!empty($form['sections']) ? $form['sections'] : array();
			foreach($vs as $kt1 => $v1){
				if(empty($v1['position']))continue;
				$positions = explode(' ',trim($v1['position']));
				$k0 = isset($positions[1]) ? trim($positions[1]) : '0';
				$k = trim($positions[0]);
				if(trim($key) !=$k) continue;
				$k1=!empty($v1['section_title']) ? $v1['section_title'] : '';
				$vf=!empty($v1['section_elements']) ? $v1['section_elements'] : array();
				foreach($vf as $k2 => $v2){
					if(!empty($v2['column'])){
						$data=array();
						$data[]=$v2['column'];
						$data[]=!empty($v2['description']) ? $v2['description'] : '';
						$data[]=!empty($v2['class']) ? $v2['class'] : '';
						$data[]=!empty($v2['type']) ? $v2['type'] : '';
						$data[]=!empty($v2['required']) ? $v2['required'] : '';
						$data[]=!empty($v2['disabled']) ? $v2['disabled'] : false;
						$data[]=!empty($v2['source']) ? $this->source_encode($v2['source']) : '';
						$data[]=!empty($v2['value']) ? $v2['value'] : '';
						$data[]=isset($v2['empty']) ? $v2['empty'] : true;
						//$data[]=!empty($v2['event']) ? $v2['event'] : '';
						//$data[]=!empty($v2['target']) ? $v2['target'] : '';
						//$dt[]=json_encode($data);
						$dt[]=implode(',',$data);
					}
				}
			}
			return implode('|', $dt);
		}

		//Used to identify the form elements for each type of data gotten from database to be able to custom form format the data to suit the element.
		public function extractFormElements($form){
			$data = [];
			if(isset($form->sections)):
				foreach ($form->sections as $key => $value) :
					if(isset($value->section_elements)):
						foreach ($value->section_elements as $se_key => $se_value) :
							$data[] = (object)$se_value;
						endforeach;
					endif;
				endforeach;
			endif;
			return $data;
		}


		//Loads matched rows from database or source param
		function load_data_from_param($param_name, $data_key = "")	{
			$response 				= [];
			$retrieve_filter 	= "";
			//If param name supplied is an array.
			if(gettype($param_name) == "array" || gettype($param_name) == "object"){
				if(gettype($param_name) == "object")$param_name = json_decode(json_encode($param_name), true);
				extract($param_name, EXTR_OVERWRITE);
			}else {
				$pageType = $param_name;
			}
			// Check sources first
			$sources = $this->get_page_param("sources");
			// If data is not found in sources
			if(!empty($pageType)){
				if(!isset($sources->{$pageType})){
					$param = $this->get_params($pageType);
					if(empty($param))
					$response = [];
					// Param is found in any of the pages
					else{
						$display_fields = $param->display_fields;
						$display_fields = $display_fields[0];
						$first_column		=	$display_fields->column;
						$sort			 			= "$first_column DESC";
						// if there is an external column that came from the array above, use it.
						if(isset($column))$first_column = $column;
						if(gettype($first_column) == "array")$first_column = implode(", ", $first_column);
						if(empty($param->sort))$param->sort = "";
						if(empty($param->retrieve_filter))$param->retrieve_filter = "";
						//Merge filter queries from ajax request with the one from the param
						$param->retrieve_filter = str_replace(" and ", ",", $param->retrieve_filter);
						$param->retrieve_filter = implode(",", array_filter([$retrieve_filter, $param->retrieve_filter]));
						//Get Data
						$data = self::$generic->getFromTable($param->table, $param->retrieve_filter, 1, 0, $param->sort, false, "{$param->primary_key}, $first_column");
						if(!empty($data)){
							$response = [];
							$countcols = explode(",", $first_column);
							foreach ($data as $key => $value):
								$response[$value->{$param->primary_key}] = ((count($countcols) > 1) || !empty($usekey)) ? $value : $value->{$first_column} ;
							endforeach;
						}
					}
				}else{
					$response = $sources->{$pageType};
					$response = json_decode(json_encode($response), true);
				}
				if(strlen(trim($data_key))){
					if(isset($response[$data_key]))$response = $response[$data_key];
					else $response = "";
				}
			}
			return $response;
		}

	}

?>
