<?php
require_once "Generic.php";
require_once "ParamControl.php";

class TableControl{
  public static $generic;
  public static $db;
  public static $remove = array();

  public function __construct($generic) {
    self::$generic = $generic;
  }

  public function run($queries, $callback)  {
    $c = 0;
    $response = [];
    $db = self::$generic->connect();
    self::$db = $db;
    if(gettype($queries) === "string"){
      $nums = explode("-", $queries);
      $queries = [];
      $first = (int) filter_var($nums[0], FILTER_SANITIZE_NUMBER_INT);
      $last  = (int) filter_var($nums[1], FILTER_SANITIZE_NUMBER_INT);
      for($i=$first; $i<=$last; $i++) {
        $queries[] = "query$i";
      }
    }
    foreach($queries as $k => $_query){
      $_query = trim($_query);
      global ${$_query};
    	if(isset(${$_query})){
    		$fields = $this->get_all_table_fields(${$_query});
    		$counter = 0;
    		$tablename = $fields->query->table;
    		if(isset($fields->mysql)){//If this query already has a database table
    			foreach($fields->query->column_names as $k => $colname){//Loop through each query columns
    				$key = array_search($colname, $fields->mysql->column_names);
    				$db_col_details = ($key !== false) ? $fields->mysql->row[$key] : "";//This database column details
    				$qu_col_details = $fields->query->row[$k];                          //This query column details
    				if(array_search($colname, $fields->mysql->column_names) === false){//if this query column doesnt exist in database (Add)
    					$prev = "";
    					if(isset($fields->query->column_names[$k-1])){
    						$prev = $fields->query->column_names[$k-1];
    						$prev = "AFTER $prev";
    					}
    					$add = "ALTER TABLE $tablename ADD $colname $qu_col_details $prev";
    					if($db->query($add) or die($db->error." ($add)")){
                $response[] = "$colname added<br>";
    						$counter++;
    					};
    				}else if(($qu_col_details !== $db_col_details) && !empty($db_col_details)){//Exists but details don't match (Modify)
    					$add = "ALTER TABLE $tablename MODIFY $colname $db_col_details";
    					//$db->query($add) or die($db->error." ($add)");
    				}
    			}
          $response[] = "$counter columns affected on $tablename table";
    		}else{
    			$query = ${$_query};
    			$db->query($query) or die($db->error."($query)");
          $response[] = "$tablename created";
    		}
    		$c++;
        $response[] = "----------------------><br>";
        $this::$remove[] = $fields;
    	}
    }
    if(gettype($callback) == "object"){
      call_user_func($callback, $response);
    }
    $db->close();
    return $response;
  }

  function get_all_table_fields($_query){
  	$db = self::$db;
    $all = new stdClass;
  	$query =  $this->queryToArray($_query);
  	$table = $query->table;
  	$all->query = $query;
  	//fetch existing columns from database table and build array with tablename
  	if($sql = $db->query("SHOW CREATE TABLE $table")){
  		if($row = $sql->fetch_assoc()){
  			$mysql =  $this->queryToArray($row['Create Table']);
  			$all->mysql = $mysql;
  		}
  	}
  	return $all;
  }

  function queryToArray($query){
  	//Returns tablename, column names, datatypes
  	$q = str_replace('`','',$query);
  	$arr = explode('(', $q, 2);
  	$arr1 = substr($arr[1],0,-1);
  	$arr0 = explode(' ', trim($arr[0]));
  	//Get the table name
  	$table = end($arr0);
  	//split the query into columns and cleanup
  	$cols = preg_split('/\r\n|\r|\n/', $arr1);
  	$cols = array_map('trim', $cols);
  	$cols = array_filter($cols);
  	$response = new stdClass; $_qu = $_qus = array();
  	//extract columns from query and build array with tablename
  	$response->table = $table;
  	foreach($cols as $col_){
  		if(!empty($col_)){
  			$column_name = explode(' ',trim($col_))[0];
  			if(strlen($column_name) > 1){
  				if(stripos($column_name, 'primary') === false && stripos($column_name, 'unique') === false){
  					$response->column_names[] = trim($column_name);//Column names only
  					$response->row[] = substr($col_, -1) == ',' ?
  						strtolower(trim(str_replace($column_name, '', substr($col_, 0, -1)))) :
  						strtolower(trim(str_replace($column_name, '', $col_)));// Column details
  				}
  			}
  		}
  	}
  	return $response;
  }

  public function drop_columns()  {
    return $this::$remove;
  }
  public function update_generic_tables()  {
    $clientid=1;
    $paramControl = new ParamControl(self::$generic);
    $default_role = $paramControl->default_role();
    $db = self::$db;
    $query6="REPLACE into roles(
      roleid, transcid, clientid, rolename, roledesc)
      values
      ('1', concat(unix_timestamp(),round((rand() * 100) * (rand() * 100) )), '$clientid', 'Administrator', '$default_role'
    )";
    if($db->query($query6) or die($db->error)){
      $response[] = "Admin Role Added";
      $response[] = "----------------------><br>";
    }
    $query8="REPLACE into users(id,username, password, first_name, roleid, accesslevel, status, type, email) values ('1','administrator','email@admin','administrator','1','4','1','1','info@digitaldreamsng.com')";
    if($db->query($query8) or die($db->error)){
      $response[] = "Administrator Added";
      $response[] = "----------------------><br>";
    }
    $query2="REPLACE into company_info(id,name) values ('1','Set me up !!!')";
    if($db->query($query2) or die($db->error)){
      $response[] = "Default Company Added";
      $response[] = "---------------------->";
    }
    return $response;
  }

}





/*
function archiveDirectory(&$zip, $dir)
{
	$files=array();
	// Open a known directory, and proceed to read its contents
	if (is_dir($dir)) {
		if ($dh = opendir($dir)) {
			while (($file = readdir($dh)) !== false) {
				$files[]=$file;
			}
			closedir($dh);
			for($i=0;$i<count($files);$i++)
			{
				if($files[$i]=="." || $files[$i]==".." || $files[$i]=="...") continue;
				$directory=$dir."/".$files[$i];
				$filename=substr($directory,2);
				if(is_dir($dir."/". $files[$i])){archiveDirectory($zip,$directory);}
				else $zip->addFile($directory,$filename);
			}
		}
	}
}
function archiveArray(&$zip,&$files)
{
	for($i=0;$i<count($files);$i++)
	{
		if(!file_exists($files[$i]))continue;
		if($files[$i]=="." || $files[$i]==".." || $files[$i]=="...") continue;
		$directory=$files[$i];
		$filename=substr($directory,2);
		if(is_dir( $files[$i])){archiveDirectory($zip,$directory);}
		else $zip->addFile($directory,$filename);
	}
}

function backupDatabase($db)
{
	$number=0;$text="";
	$t_result=$db->query("show tables");
	while(list($table)=$t_result->fetch_array()){
		$d_count=0;$number=0;
		$text .="drop table if exists $table;~% ";
		$text .="create table $table (";
		$d_result=$db->query("describe $table") or die($db->error);
		while($d_line=$d_result->fetch_assoc())
		{
			if($d_count) $text .=",";
			$text .=$d_line["Field"]." ".$d_line["Type"];
			if($d_line["Null"] !="YES")$text .=" not null";
			$text .=" ".$d_line["Extra"]."";
			if($d_line["Key"]!="")$text .=", primary key(".$d_line["Field"].")";
			$d_count++;
		}
		$text .=");~%";
		$query="select * from $table";
		$result=$db->query($query) or die($db->error);
		while($line=$result->fetch_assoc())
		{

			if($number !=0) $text .=","; else $text .="insert into $table values ";
			$val_count=0;
			$text .="(";
			foreach($line as $val)
			{
				if($val_count !=0) $text .=",";
				$val=$db->real_escape_string($val);
				if(empty($val)) {$text .="NULL"; }
				else $text .="'$val'";
				$val_count++;
			}
			$text .= ")";
			$number++;
		}
		if($number !=0)$text .=";~%";

	}
	$t_result->free_result();
	return $text;
}


function backupTable($db, $table)
{
	$text="";
	$d_count=0;$number=0;
	$text .="drop table if exists $table;~% ";
	$text .="create table $table (";
	$d_result=$db->query("describe $table") or die($db->error);

	while($d_line=$d_result->fetch_assoc())
	{
		if($d_count) $text .=",";
		$text .=$d_line["Field"]." ".$d_line["Type"];
		if($d_line["Null"] !="YES")$text .=" not null";
		$text .=" ".$d_line["Extra"]."";
		if($d_line["Key"]!="")$text .=", primary key(".$d_line["Field"].")";
		$d_count++;
	}
	$text .=");~%";
	$query="select * from $table order by id";
	$result=$db->query($query) or die($db->error);
	while($line=$result->fetch_assoc())
	{

		if($number !=0) $text .=","; else $text .="insert into $table values ";
		$val_count=0;
		$text .="(";
		foreach($line as $val)
		{
			if($val_count !=0) $text .=",";
			$val=$db->real_escape_string();
			$text .="'$val'";
			$val_count++;
		}
		$text .= ")";
		$number++;
	}
	if($number !=0)$text .=";~%";
	return $text;
}
function backupFields($db, $table,$fields)
{
	$text="";
	$d_count=0;$number=0;
	$text .="drop table if exists $table;~% ";
	$text .="create table $table (";
	$d_result=$db->query("describe $table") or die($db->error);
	while($d_line=$d_result->fetch_assoc())
	{
		if(!array_keys($fields,$d_line["Field"]))continue;
		if($d_count) $text .=",";
		$text .=$d_line["Field"]." ".$d_line["Type"];
		if($d_line["Null"] !="YES")$text .=" not null";
		$text .=" ".$d_line["Extra"]."";
		if($d_line["Key"]!="")$text .=", primary key(".$d_line["Field"].")";
		$d_count++;
	}
	$text .=");~%";
	$query="select ";
	$field_count=0;
	for($i=0;$i<count($fields);$i++)
	{
		if($field_count)$query .=",";
		$query .=$fields[$i];
		$field_count++;
	}
	$query .=" from $table order by id";
	$result=$db->query($query) or die($db->error);
	while($line=$result->fetch_assoc())
	{

		if($number !=0) $text .=","; else $text .="insert into $table values ";
		$val_count=0;
		$text .="(";
		foreach($line as $val)
		{
			if($val_count !=0) $text .=",";
			$val=$db->real_escape_string($val);
			$text .="'$val'";
			$val_count++;
		}
		$text .= ")";
		$number++;
	}
	if($number !=0)$text .=";~%";
	return $text;
}

function getBackupPics($db,$table)
{
	$query="select picture_ref from $table where picture_ref <> '' order by id ";
	$result=$db->query($query) or die($db->error);
	while($line=$result->fetch_assoc())
	{
		$files[]="./Pictures/".$line["picture_ref"];
	}
	return $files;
}

function runQuery($file){
	global $db;
	if(file_exists($file)){
		$handle=fopen($file,"r");
		if($handle)
		{
			$query = fread($handle, filesize($file));
			fclose($handle);
		}
		$query_set=explode(";~%",$query);
		$num=count($query_set)-1;
		for($i=0;$i<$num;$i++)
		{
			$db->query($query_set[$i]) or die($db->error);
		}
	}
}


function getSync($db, $table)
{
	$text="";
	$query="select query from $table";
	$result=$db->query($query) or die($db->error);
	while($row=$result->fetch_assoc())
	{
		$text .=$row["query"].";";
	}
	return $text;
}
function runQueryText($sql)
{
	$query = $sql;
	$query_set=explode(";~%",$query);
	$num=count($query_set)-1;
	for($i=0;$i<$num;$i++)
	{
		$db->query($query_set[$i]) or die($db->error);
	}
}

function zipDir($source, $destination){
    if (!extension_loaded('zip') || !file_exists($source)) {
        return false;
    }

    $zip = new ZipArchive();
    if (!$zip->open($destination, ZIPARCHIVE::CREATE)) {
        return false;
    }

    $source = str_replace('\\', '/', realpath($source));

    if (is_dir($source) === true)
    {
        $files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($source), RecursiveIteratorIterator::SELF_FIRST);

        foreach ($files as $file)
        {
            $file = str_replace('\\', '/', $file);

            // Ignore "." and ".." folders
            if( in_array(substr($file, strrpos($file, '/')+1), array('.', '..')) )
                continue;

            //$file = realpath($file);

            if (is_dir($file) === true){
                $zip->addEmptyDir(str_replace($source . '/', '', $file . '/'));
            }
            else if (is_file($file) === true)
            {
                $zip->addFromString(str_replace($source . '/', '', $file), file_get_contents($file));
            }
        }
    }
    else if (is_file($source) === true)
    {
        $zip->addFromString(basename($source), file_get_contents($source));
    }

    return $zip->close();
}

function extractZip($zipFile, $extract_to){
	$zip = new ZipArchive;
	if(!is_dir($extract_to)){mkdir($extract_to,true, 0755);}
	$res = $zip->open($zipFile);
	if ($res === TRUE) {
	  	$zip->extractTo($extract_to);
	  	$zip->close();
		return true;
	} else {
	  return false;
	}
}

function emptyDir($dir){
	if(is_dir($dir)){
		$di = new RecursiveDirectoryIterator($dir, FilesystemIterator::SKIP_DOTS);
		$ri = new RecursiveIteratorIterator($di, RecursiveIteratorIterator::CHILD_FIRST);
		foreach ( $ri as $file ) {
			//$file = $file->getRealPath();
			$file->isDir() ?  rmdir($file) : unlink($file);
		}
		return true;
	}
}

public function backupDatabase($value=''){
$dir = "../database/backups/";
if(!is_dir($dir)){
  mkdir($dir,true,0755);
}
$file=$dir."DataBackup".time().".sql";
$handle=fopen($file,"w+");
if($handle){
  $text=backupDatabase($db);
  if(fwrite($handle, $text, strlen($text)))
  {
    fclose($handle);
    $asset = '../asset/';
    $zipfile = str_replace('.sql','',$file).'.zip';
    zipDir($asset, $zipfile);
    $target_url = 'http://www.enugucathsec2.org/rear/backup_restore_database.php';
    //$target_url = 'http://localhost/enugu_diocese/rear/backup_restore_database.php';
    $headers = array("Content-Type" => "multipart/form-data");
    $post = array(
      'sqlFile' => makeCurlFile($file),
      'zipFile' => makeCurlFile($zipfile)
    );
    $ch = curl_init($target_url);
    curl_setopt($ch, CURLOPT_POST,1);
    curl_setopt($ch, CURLOPT_SAFE_UPLOAD, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
    $result = curl_exec($ch);
    if (curl_errno($ch)) {
       $result = curl_error($ch);
    }
    curl_close ($ch);
    unlink($zipfile);
    echo($result);
  }
}


$db->close();
}

public function restoreDatabase($value='')
{
extract($_POST, EXTR_OVERWRITE);
$dir = "../database/backups/";
$asset = '../asset/';
if(!is_dir($dir)){
  mkdir($dir,true,0755);
}
if(isset($_FILES)){
  foreach($_FILES as $posted => $file){
    $name = $_FILES[$posted]["name"];
    $filename = $dir.$name;
    if(move_uploaded_file($_FILES[$posted]["tmp_name"], $filename)){
      switch($posted){
        case 'sqlFile':
          runQuery($filename);
        break;
        case 'zipFile':
          emptyDir($asset);
          extractZip($filename, $asset);
        break;
      }
    }
  }
  emptyDir($dir);
}
echo 'done';
}

function makeCurlFile($file){
  $file = realpath($file);
  $mime = mime_content_type($file);
  $info = pathinfo($file);
  $name = $info['basename'];
  $output = new CURLFile($file, $mime, $name);
  return $output;
}

*/
?>
