$.fn.extend({
	autocomplete: function(obj){
		// This makes use of {source:[string or array], validate:[bool], callback:[function]}
		// if obj.source is set, it loads the dropdown from the source if it's already an array;
			//but if it's a string, it sends it to server as a paramName to be extracted from the param;
		// if obj.display_fields is set, it displays those fields in the dropdown
		// if obj.value is set, it sets the value as the textbox value on select
		var $this = $(this);
		$(this).off('blur');
		$(this).off('keyup');
		$(this).attr({autocomplete:"off"});
		$(this)[0].data = [];
		$(this)[0].display_fields = obj.display_fields || null;
		$(this)[0].insert_field = obj.value || null;
		if(!obj.source){
			alert('AutoComplete requires source');
			$(this).attr({disabled:true});
			return;
		}else{
			if(typeof(obj.source) == "string"){
				let $send = {};
				let keyname = $(this).attr("name");
	      $send[keyname] = {
	        source: obj.source,
	      };
	      $.post(site.process_url+"?case=2", $send, function(response) {
	        let data = isJson(response);
	        if (data[keyname]) data = data[keyname];
					$this[0].data = data;
	      })
			}else{
				$this[0].data = obj.source;
			}
		}

		$this.val('');
		// When any key as been punched
		$this.keyup(function(){
			$(this).perfomSearch(obj);
		})
		.focus(function() {
			$(this).siblings("label[for]").addClass("active");
			$(this).perfomSearch(obj);
		})
		.blur(function(){
			let ths = this;
			let box = $(ths).parent();
			setTimeout(function(){
				box.find('.combo-search').hide();
				if(obj.validate && obj.validate === true){
					// Cross-check the values again
				}
			},150);
		})
	}
})

$.fn.extend({
	validateBox:function(obj){
		var $this = $(this), response = false, CurrentText = $this.val();
		if(obj.source && obj.source.length){
			$this.removeClass('err-pink');
			for(var index in obj.source){
				var t = obj.source[index].toLowerCase();
				if(CurrentText.toLowerCase() == t){
					response = true;
					$('#'+obj.buttonContainer).find('button').removeAttr('disabled').removeClass('dis-btn');
					break;
				}
			}
		}
		return response;
	}
});

$.fn.extend({
	perfomSearch:function(obj){
		// Define parameters
		$this = $(this);
		let searchArray = $(this).prop('data'), OldText = "", box, wiDth,height,index=0, CurrentText, Newtext;
		// Get the container of them input field
		box = $(this).parent().css({'position':'relative'});
		// Get the width and height of the input element to be able to position the search dropdown
		wiDth = box.width();
		height = box.height() - parseInt(15);
		// Create dropdown if not there already
		if(box.find('.combo-search').length < 1){
			$('<div>').addClass('combo-search dropdown').css({width:wiDth, top:height}).appendTo(box);
		}
		// Get the characters you have typed into the field
		CurrentText = Newtext = $this.val().toLowerCase().trim();
		// Get the dropdown and empty it
		var searchcontainer = box.find('.combo-search');
		box.find('.combo-search').empty().show();
		//If the characters you have typed into the field contains comma,  treat it as a new word
		if(Newtext.indexOf(',') > 0){
			//Save the other words other than the last one while taking the last one as the CurrentText
			let arrText = Newtext.split(',');
			let lastval = arrText.pop();
			OldText = arrText.join(",");
			CurrentText = lastval
		}else{
			//Else retain the initial value
			 CurrentText = Newtext;
		}
		// THE ULTIMATE SEARCH ALOGORITHM BEGINS
		// loop through the source array
		for(let index in searchArray){
			var thisline = '';
			// Exclude empty values
			if(searchArray[index]==null){continue;}
			// Convert to string if it a multidementional array
			if(typeof(searchArray[index]) == 'object'){
				let values = Object.values(searchArray[index]);
				thisline = values.join(" ");
			}else thisline = searchArray[index];
			// Reduce to small letter and trim external white spaces
			thisline = thisline.toLowerCase().trim();
			// If the search gets a match
			if(thisline.indexOf(CurrentText)>-1){
				// Format the text to append on the input
				// Format the text to use as display_fields
				let display_field = searchArray[index];
				// If the selected line happens to be an object
				if(typeof(display_field) == "object"){
					let display_fields = $this.prop("display_fields");
					let sel_fields 		 = [];
					// Format Display Fields only
					if(display_fields){
						display_fields = display_fields.split(",");
						// Trim excesive white spaces from the display_fields and remove empty values
						display_fields = display_fields.map(s => s.trim());
						display_fields = display_fields.filter(s => s != "");
						for(let ind in display_fields){
							//Get only existing display_fields from the current object
							if(display_field[display_fields[ind]] !== undefined){
								sel_fields.push(display_field[display_fields[ind]]);
							}
						}
					}else{
						sel_fields = Object.values(display_field)
					}
					display_field = sel_fields.join(" ").trim();
				}
				// Join old text and selected texts
				$('<a>').appendTo(searchcontainer).attr({id:'ch'+index, key:index}).addClass('itm ').css({'cursor':'pointer'}).text(display_field).on('click',function(){
					let searchArray = $this.prop('data');
					let index = $(this).attr("key");
					let selected = searchArray[index];
					// If the selected line happens to be an object
					if(typeof(selected) == "object"){
						let ins_fields = [];
						let insert_fields  = $this.prop("insert_field");
						if(insert_fields){
							insert_fields = insert_fields.split(",");
							// Trim excesive white spaces from the insert_fie lds and remove empty values
							insert_fields = insert_fields.map(s => s.trim());
							insert_fields = insert_fields.filter(s => s != "");
							for(let ind in insert_fields){
								//Get only existing insert_fields from the selected object
								if(selected[insert_fields[ind]] !== undefined){
									ins_fields.push(selected[insert_fields[ind]]);
								}
							}
							selected = ins_fields.join(", ");
						}else{
							selected = display_field;
						}
					}
					selected = [OldText, selected].filter(function (el) {return el != "";	});
					$this.val(selected.join(", ")).attr({"data-value":index});
					if(typeof(obj.callback) == "function"){
						let callback = obj.callback;
						callback(searchArray[index]);
					}
					setTimeout(function(){
						box.find('.combo-search').remove();
					}, 50);
				});
			}
		}
	}
})
